
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <unistd.h>

#include "commands.h"
#include "helpers.h"
#include "constants.h"

/* search the action response file for a response for a given action
	this one will read the new format of the action/response file
	now it will grab a random line after the keyword tag */
int ActionResponse(char * response, const char * msg, const char * user, const char *room)
{
	FILE *fp;
	char action[MAX_LINE_LEN+20];
	char l_response_1[MAX_LINE_LEN+20],l_response_2[MAX_LINE_LEN+20],l_response_3[MAX_LINE_LEN+20],l_response_4[MAX_LINE_LEN+20],l_response_5[MAX_LINE_LEN+20];
	char tempresponse[MAX_LINE_LEN+20];
	int i = 0;
	int j = 0;
	int randAction = 0;

	fp=fopen(F_ACTION_RESPONSE,"r");
	char msg2[strlen(msg)];

	/* convert the message to lowercase */
	i = 0;
	while(i < strlen(msg))
	{
		msg2[i] = tolower(msg[i]);
		i++;
	}

	for(;;)
	{
		j = 0;
		/* grab a random number */
		srand(time(0));
		randAction = rand()%6;		/* set this to 1 more than the number of possible responses */

		/* get the action response pair from the file */
		fgets(action,MAX_LINE_LEN,fp);
		fgets(l_response_1,MAX_LINE_LEN,fp);
		fgets(l_response_2,MAX_LINE_LEN,fp);
		fgets(l_response_3,MAX_LINE_LEN,fp);
		fgets(l_response_4,MAX_LINE_LEN,fp);
		fgets(l_response_5,MAX_LINE_LEN,fp);

		/* get rid of new line at end of the strs */
		action[strlen(action)-1]='\0';

		/* convert the action to lowercase */
		j = 0;
		while(j < strlen(action))
		{
			action[j] = tolower(action[j]);
			j++;
		}

		l_response_1[strlen(l_response_1)-1]='\0';
		l_response_2[strlen(l_response_2)-1]='\0';
		l_response_3[strlen(l_response_3)-1]='\0';
		l_response_4[strlen(l_response_4)-1]='\0';
		l_response_5[strlen(l_response_5)-1]='\0';

		/* somebody said something that we have a response for */
		if(strstr(msg2,action)!=NULL)
		{
			/* msg contains action */
			fclose(fp);

			random_sleep(6);

			switch (randAction)
			{
				case 1:
				{
					/* replace meta characters */
					if(strstr(l_response_1,"%s"))
					{
						strcpy(tempresponse,l_response_1); /* make a copy */
						sprintf(l_response_1,tempresponse,user);
					}
					/* replace meta characters */
					if(strstr(l_response_1,"%r"))
					{
						strcpy(tempresponse,l_response_1); /* make a copy */
						sprintf(l_response_1,tempresponse,room);
					}

					/* copy the response to the outside string */
					strcpy(response,l_response_1);
					break;
				}
				case 2:
				{
					/* replace meta characters */
					if(strstr(l_response_2,"%s"))
					{
						strcpy(tempresponse,l_response_2); /* make a copy */
						sprintf(l_response_2,tempresponse,user);
					}
					/* replace meta characters */
					if(strstr(l_response_2,"%r"))
					{
						strcpy(tempresponse,l_response_2); /* make a copy */
						sprintf(l_response_2,tempresponse,room);
					}

					/* copy the response to the outside string */
					strcpy(response,l_response_2);
					break;
				}
				case 3:
				{
					/* replace meta characters */
					if(strstr(l_response_3,"%s"))
					{
						strcpy(tempresponse,l_response_3); /* make a copy */
						sprintf(l_response_3,tempresponse,user);
					}
					/* replace meta characters */
					if(strstr(l_response_3,"%r"))
					{
						strcpy(tempresponse,l_response_3); /* make a copy */
						sprintf(l_response_3,tempresponse,room);
					}

					/* copy the response to the outside string */
					strcpy(response,l_response_3);
					break;
				}
				case 4:
				{
					/* replace meta characters */
					if(strstr(l_response_4,"%s"))
					{
						strcpy(tempresponse,l_response_4); /* make a copy */
						sprintf(l_response_4,tempresponse,user);
					}
					/* replace meta characters */
					if(strstr(l_response_4,"%r"))
					{
						strcpy(tempresponse,l_response_4); /* make a copy */
						sprintf(l_response_4,tempresponse,room);
					}

					/* copy the response to the outside string */
					strcpy(response,l_response_4);
					break;
				}
				case 5:
				{
					/* replace meta characters */
					if(strstr(l_response_5,"%s"))
					{
						strcpy(tempresponse,l_response_5); /* make a copy */
						sprintf(l_response_5,tempresponse,user);
					}
					/* replace meta characters */
					if(strstr(l_response_5,"%r"))
					{
						strcpy(tempresponse,l_response_5); /* make a copy */
						sprintf(l_response_5,tempresponse,room);
					}

					/* copy the response to the outside string */
					strcpy(response,l_response_5);
					break;
				}
				default:
				{
					/* replace meta characters */
					if(strstr(l_response_1,"%s"))
					{
						strcpy(tempresponse,l_response_1); // make a copy
						sprintf(l_response_1,tempresponse,user);
					}
					/* replace meta characters */
					if(strstr(l_response_1,"%r"))
					{
						strcpy(tempresponse,l_response_1); /* make a copy */
						sprintf(l_response_1,tempresponse,room);
					}

					/* copy the response to the outside string */
					strcpy(response,l_response_1);
					break;
				}
			}

			return 1;
		}

		/* hit bottom of file */
		if(fgetc(fp)==EOF) break;
	}

	fclose(fp);
	return 0;
}

/* search the action response file for a response for a given action */
int DefineResponse(char * response, const char * msg, const char * user)
{
	FILE *fp;
	char action[MAX_LINE_LEN+20],l_response[MAX_LINE_LEN+20];
	char tempresponse[MAX_LINE_LEN+20];
	char msg2[strlen(msg)];
	int i = 0;
	int j = 0;

	fp=fopen(F_DICTIONARY,"r");

	/* convert the message to lowercase */
	i = 0;
	while(i < strlen(msg))
	{
		if(isupper(msg[i]))
			msg2[i] = tolower(msg[i]);
		else
			msg2[i] = msg[i];
		i++;
	}

	for(;;)
	{
	j = 0;
		/* get the action response pair from the file */
		fgets(action,MAX_LINE_LEN,fp);
		fgets(l_response,MAX_LINE_LEN,fp);

		/* get rid of new line at end of the strs */
		action[strlen(action)-1]='\0';

		/* convert the action to lowercase */
		while(j < strlen(action))
		{
			if(isupper(action[j]))
				action[j] = tolower(action[j]);
			else
				action[j] = action[j];
			j++;
		}

		/* convert the action to lowercase */
		j = 0;
		while(j < strlen(action))
		{
			if(isupper(action[i]))
				action[j] = tolower(action[j]);
			else
				action[j] = action[j];
			j++;
		}

		l_response[strlen(l_response)-1]='\0';

		/* somebody said something that we have a response for
			by making sure msg and action are the same length,
			we are ensuring that we have a perfect match */
		if(strstr(msg2,action)!=NULL && strlen(msg) == strlen(action))
		{
			/* msg contains action */
			fclose(fp);

			/* replace meta characters */
			if(strstr(l_response,"%s"))
			{
				strcpy(tempresponse,l_response); /* make a copy */
				sprintf(l_response,tempresponse,user);
			}

			/* copy the response to the outside string */
			strcpy(response,l_response);
			return 1;
		}

		/* hit bottom of file */
		if(fgetc(fp)==EOF) break;
	}

	fclose(fp);
	return 0;
}


/* Local Variables: */
/* tab-width: 3 */
/* End: */
